//--------------------------------------------------------------------------
//
// MACRO: APPEND
//
// Use this macro to append an external file to the end of the current edit
// file.
//
// This macro takes one parameter, the external file name.
//
// If you specify a fully qualified file name (path + name), that file is
// appended.
// 
// If you specify file name only (no path), the file is assumed to be in the
// current directory.
//
// If you do not specify the file name, a dialog is presented where you can
// enter the file name or navigate to the file via the Common Open Dialog.
//
//--------------------------------------------------------------------------
void append(int argc, char *argv[]) {
 
  char *command;
   
  // position to bottom line of file
  SPFservice("cmd","l .zlast");
  // put cursor on last line
  SPFservice("set","cursor_row","1");
  if (argc == 2) {
    command = StrCompose("import ",argv[1]); // import specific file name
    }
  else {
    command = "import";
  }
  // import external file at last line of current file
  SPFservice("cmd",command);
   
} // append
