//------------------------------------------------------------------------
// This macro appends a string to the end of the current cursor line for a
// specific number of lines.
//
// Only text lines participate in the append operation.
//
// Macro reuires 2 parameters:
//
// P1 = string-to-append
//
// P2 = number-of-lines
//
//------------------------------------------------------------------------
void AppendString(int argc, char *argv[]) {

  char *append_str;
  char *cur_line_data;
  char *context;
  int   line_count;
  int   line_number;
  int   lines_in_file;
  int   max_line_count;
  int   i;
  bool  any_error = FALSE;

  if (argc == 3) {
    context = SPFservice("query","context");
    if (context == "EDIT") {
      i = SPFservice("query","line_number");
      if (i == 0) {
        any_error = TRUE;
        Msg("NEWPSWD:  Cursor must be on a data line when this macro is invoked.");
      }
      }
    else {
      any_error = TRUE;
      Msg("NEWPSWD:  You must be in Edit on a file to invoke this macro.");
    }
    if (!any_error) {
      append_str = argv[1]; // get P1
      line_count = argv[2]; // get P2
      line_number = SPFservice("query","line_number");  // get current ordinal line number
      lines_in_file = SPFservice("query","line_count"); // get number of lines in file
      max_line_count = lines_in_file - line_number + 1;
      if (line_count > max_line_count)
        line_count = max_line_count;
      i = 1;
      while (i <= line_count) {
        cur_line_data = SPFservice("query","line_data"); // get current cursor line
        strcat(cur_line_data,append_str);                // append string to line
        SPFservice("set","line_data",cur_line_data);     // put modified line back into file
        SPFservice("cmd","cursormove down 1");           // move cursor to next line
        ++i;                                             // incr line count
      } // while
    }
    }
  else {
    Msg("APPENDSTRING:  requires two parameters:\n\nP1 = string-to-append\n\nP2 = number-of-lines");
  }

} // AppendChar
