//---------------------------------------------------------------------
//
// MACRO:    COPYCOBOL
//
// FUNCTION: Cut a block of lines from a non-COBOL source for pasting
//           into a  COBOL source.
//
// To use this macro put label ".A" on the first line to be copied
// and label ".B" on the last line to be copied. Then invoke the macro.
//
//---------------------------------------------------------------------
void copycobol(void) {

  // shift labeled block of lines right six
  spfservice("cmd","locate .a");
  spfservice("cmd",":))6");
  spfservice("cmd","locate .b");
  spfservice("cmd",":))");
  spfservice("cmd","enter");

  // copy labeled block of lines
  spfservice("cmd","locate .a");
  spfservice("cmd",":zz");
  spfservice("cmd","locate .b");
  spfservice("cmd",":zz");
  spfservice("cmd","copy");

  // shift labeled block of lines left six
  spfservice("cmd","locate .a");
  spfservice("cmd",":((6");
  spfservice("cmd","locate .b");
  spfservice("cmd",":((");
  spfservice("cmd","enter");

  // re-position to top of block
  spfservice("cmd","locate .a");

  // reset labels
  spfservice("cmd","reset label");

} // copycobol
