//--------------------------------------------------------
// This macro deletes all empty lines.
//
// An empty line is one of the following:
//
//    * Line has no characters
//
//    * Line has all blank characters
//
//--------------------------------------------------------
void delemptylines(void) {

  char *cmd;
  char *msg;
  char *line_data;
  char *cur_char;
  int   i, j;
  int   cur_char_pos;
  int   line_length;
  int   lines_deleted = 0;
  bool  found_non_blank;

  i = 1;
  j = SPFservice("query","line_count");
  if (j > 0) {
    while (i <= j) {
      cmd = StrCompose("locate ",i); // synthesize locate command
      SPFservice("cmd",cmd);         // locate to next line
      line_length = SPFservice("query","line_length"); // get line length
      found_non_blank = FALSE;
      if (line_length > 0) {
        line_data = SPFservice("query","line_data"); // get line data
        cur_char_pos = 1;
        while (!found_non_blank && cur_char_pos <= line_length) {
          cur_char = strgetsubstr(line_data,cur_char_pos,1); // get next char
          if (cur_char != " ")
            found_non_blank = TRUE;
          else
            ++cur_char_pos;
        } // while
      }
      if (!found_non_blank) {
        //------------------
        // delete empty line
        //------------------
        SPFservice("cmd",":d");
        j = SPFservice("query","line_count"); // update line count
        ++lines_deleted;             // increment lines deleted count
        }
      else {
        ++i;                         // go to next line
      }
    } // while
  }
  SPFservice("cmd","top");           // position to top of file
  if (lines_deleted) {
    msg = StrCompose(lines_deleted," empty lines deleted.");
    }
  else {
    msg = "No empty lines in this file.";
  }
  Msg(msg);

} // delemptylines
