//------------------------------------------------------------------------
// This macro converts a decimal value (in text) to a hex value (in text).
// This macro uses "C" hex notation.
//
//    Before:  ...text... 32 ...text...
//     After:  ...text... 0x20 ...text...
//
// Put cursor on first digit of decimal value in text "32".
// Invoke macro DTOX.
// Text "32" is replaced with text "0x20".
//
// Decimal values must be in range 0 to 255.
//
// This macro is most useful when modifying literal values in program source.
//
//------------------------------------------------------------------------------
void DtoX(void) {

  char *line_data;
  char *decimal_digit1;
  char *decimal_digit2;
  char *decimal_digit3;
  char *decimal_str;
  char *hex_str1;
  char *hex_str2;
  char *hex_str;
  char *pcmd;

  int   hex_digit1;
  int   hex_digit2;
  int   digit_count = 0;
  int   decimal_int;
  int   line_number;
  int   line_len;
  int   cur_col;
  int   i;

  bool  digit_err = FALSE;

  line_number = SPFservice("query","line_number");
  if (line_number > 0) {
    line_data = SPFservice("query","line_data");
    line_len = strlen(line_data);
    if (line_len >= 3) {
      cur_col = SPFservice("query","col_number");
      if (cur_col > 0) {
        i = line_len - 2; // col number at 3 from end
        if (cur_col <= i) {
          i = cur_col;
          decimal_digit1 = strgetsubstr(line_data,i,1);
          if (decimal_digit1 >= 0 && decimal_digit1 <= 9) {
            ++digit_count;
            ++i;
            decimal_digit2 = strgetsubstr(line_data,i,1);
            if (decimal_digit2 >= 0 && decimal_digit2 <= 9) {
              ++digit_count;
              ++i;
              decimal_digit3 = strgetsubstr(line_data,i,1);
              if (decimal_digit3 >= 0 && decimal_digit3 <= 9) {
                ++digit_count;
              }
            }
            strcpy(decimal_str,decimal_digit1);
            switch(digit_count) {
              case 2:
                strcat(decimal_str,decimal_digit2);
                break;
              case 3:
                strcat(decimal_str,decimal_digit2);
                strcat(decimal_str,decimal_digit3);
                break;
            } // switch
            decimal_int = decimal_str;
            hex_digit1 = decimal_int / 16;
            hex_digit2 = decimal_int % 16;
            switch (hex_digit1) {
              case  0: hex_str1 = "0"; break;
              case  1: hex_str1 = "1"; break;
              case  2: hex_str1 = "2"; break;
              case  3: hex_str1 = "3"; break;
              case  4: hex_str1 = "4"; break;
              case  5: hex_str1 = "5"; break;
              case  6: hex_str1 = "6"; break;
              case  7: hex_str1 = "7"; break;
              case  8: hex_str1 = "8"; break;
              case  9: hex_str1 = "9"; break;
              case 10: hex_str1 = "A"; break;
              case 11: hex_str1 = "B"; break;
              case 12: hex_str1 = "C"; break;
              case 13: hex_str1 = "D"; break;
              case 14: hex_str1 = "E"; break;
              case 15: hex_str1 = "F"; break;
            } // switch
            switch (hex_digit2) {
              case  0: hex_str2 = "0"; break;
              case  1: hex_str2 = "1"; break;
              case  2: hex_str2 = "2"; break;
              case  3: hex_str2 = "3"; break;
              case  4: hex_str2 = "4"; break;
              case  5: hex_str2 = "5"; break;
              case  6: hex_str2 = "6"; break;
              case  7: hex_str2 = "7"; break;
              case  8: hex_str2 = "8"; break;
              case  9: hex_str2 = "9"; break;
              case 10: hex_str2 = "A"; break;
              case 11: hex_str2 = "B"; break;
              case 12: hex_str2 = "C"; break;
              case 13: hex_str2 = "D"; break;
              case 14: hex_str2 = "E"; break;
              case 15: hex_str2 = "F"; break;
            } // switch
            strcpy(hex_str,"0x");
            strcat(hex_str,hex_str1);
            strcat(hex_str,hex_str2);
            pcmd = "CHANGE C'";
            strcat(pcmd,decimal_str);
            strcat(pcmd,"' '");
            strcat(pcmd,hex_str);
            strcat(pcmd,"'");
            SPFservice("cmd",pcmd);
            }
          else {
            msg("Cursor must be on decimal digit.");
          }
          }
        else {
          msg("Cursor too close or beyond end of line.");
        }
        }
      else {
        msg("Cursor must be on data col.");
      }
      }
    else {
      msg("Line must be at least 3 characters long.");
    }
    }
  else {
    msg("Cursor must be on data line.");
  }

} // DtoX



