//-------------------------------------------------------------------
// This Edit macro provides a way to import an external file into
// the current file using IMPORT. It then deletes the imported file.
//
// IMPORTANT NOTE: This macro assumes that the file you are importing
// is in the same directory as the file you are editing.
//
// Required parameter:  filename
//
// Example:  MOVEALL test.txt
//
//-------------------------------------------------------------------
void moveall(int argc, char *argv[]) {

  char *filename;
  char *filespec;
  char *command;
  char *RC;

  if (argc == 2) {
    filename = argv[1];
    command = strcompose("IMPORT ",filename);
    SPFservice("cmd",command);
    filespec = SPFservice("vget","ZDSNPATH");
    strcat(filespec,"\\");
    strcat(filespec,filename);
    RC = filedelete(filespec);
    if (RC != "OK") {
      msg(strcompose("MOVEALL:  file not deleted:\n\n",filespec));
    }
    }
  else {
    msg("MOVEALL:  requires one parameter:  ...filename,...");
  }

} // moveall
