//-----------------------------------------------------------------------
// This macro is designed to show the current state of selection in Edit.
// Its main purpose is to provide Edit macro writers a way to easily
// understand the values returned by query of "SELECT_*" values.
// To use simply make a selection in Edit then execute the macro via
// primary command field or PF key.
//-----------------------------------------------------------------------
void showselect(void) {

  char *s_mode;
  int   s_start_col;
  int   s_end_col;
  int   s_start_line;
  int   s_end_line;

  s_mode       = spfservice("query","SELECT_MODE");
  s_start_col  = spfservice("query","SELECT_START_COL");
  s_end_col    = spfservice("query","SELECT_END_COL");
  s_start_line = spfservice("query","SELECT_START_LINE");
  s_end_line   = spfservice("query","SELECT_END_LINE");

  msg(strcompose("Current selection:\n\nMode=",s_mode,"\nStartline=",s_start_line,"\nStartcol=",s_start_col,"\nEndline=",s_end_line,"\nEndcol=",s_end_col));

} // showselect
