//-----------------------------------------------------------------------------
//
// Use this macro to fix corrupted files.
//
// Macro assumes that valid records are terminated with CR+LF (x0D0A) sequence.
//
// Macro assumes that only ASCII characters are valid BLANK...TILDE (x20...x7E)
//
// Control characters (x00...x1F) and non-ASCII characters (x7F...xFF) are
// converted to blank.
//
// Always back up your original file before applying this macro.
//
//-----------------------------------------------------------------------------
void FixBadChars(void) {

  //------------------------------
  // change control chars to blank
  //------------------------------
  spfservice("cmd","CHANGE ALL X'00' x'20'");
  spfservice("cmd","CHANGE ALL X'01' x'20'");
  spfservice("cmd","CHANGE ALL X'02' x'20'");
  spfservice("cmd","CHANGE ALL X'03' x'20'");
  spfservice("cmd","CHANGE ALL X'04' x'20'");
  spfservice("cmd","CHANGE ALL X'05' x'20'");
  spfservice("cmd","CHANGE ALL X'06' x'20'");
  spfservice("cmd","CHANGE ALL X'07' x'20'");
  spfservice("cmd","CHANGE ALL X'08' x'20'");
  spfservice("cmd","CHANGE ALL X'09' x'20'");
  //spfservice("cmd","CHANGE ALL X'0A' x'20'"); // do not change LF
  spfservice("cmd","CHANGE ALL X'0B' x'20'");
  spfservice("cmd","CHANGE ALL X'0C' x'20'");
  //spfservice("cmd","CHANGE ALL X'0D' x'20'"); // donot change CR
  spfservice("cmd","CHANGE ALL X'0E' x'20'");
  spfservice("cmd","CHANGE ALL X'0F' x'20'");
  spfservice("cmd","CHANGE ALL X'10' x'20'");
  spfservice("cmd","CHANGE ALL X'11' x'20'");
  spfservice("cmd","CHANGE ALL X'12' x'20'");
  spfservice("cmd","CHANGE ALL X'13' x'20'");
  spfservice("cmd","CHANGE ALL X'14' x'20'");
  spfservice("cmd","CHANGE ALL X'15' x'20'");
  spfservice("cmd","CHANGE ALL X'16' x'20'");
  spfservice("cmd","CHANGE ALL X'17' x'20'");
  spfservice("cmd","CHANGE ALL X'18' x'20'");
  spfservice("cmd","CHANGE ALL X'19' x'20'");
  spfservice("cmd","CHANGE ALL X'1A' x'20'");
  spfservice("cmd","CHANGE ALL X'1B' x'20'");
  spfservice("cmd","CHANGE ALL X'1C' x'20'");
  spfservice("cmd","CHANGE ALL X'1D' x'20'");
  spfservice("cmd","CHANGE ALL X'1E' x'20'");
  spfservice("cmd","CHANGE ALL X'1F' x'20'");

  //--------------------------------
  // change non-ASCII chars to blank
  //--------------------------------
  spfservice("cmd","CHANGE ALL X'7F' x'20'");

  spfservice("cmd","CHANGE ALL X'80' x'20'");
  spfservice("cmd","CHANGE ALL X'81' x'20'");
  spfservice("cmd","CHANGE ALL X'82' x'20'");
  spfservice("cmd","CHANGE ALL X'83' x'20'");
  spfservice("cmd","CHANGE ALL X'84' x'20'");
  spfservice("cmd","CHANGE ALL X'85' x'20'");
  spfservice("cmd","CHANGE ALL X'86' x'20'");
  spfservice("cmd","CHANGE ALL X'87' x'20'");
  spfservice("cmd","CHANGE ALL X'88' x'20'");
  spfservice("cmd","CHANGE ALL X'89' x'20'");
  spfservice("cmd","CHANGE ALL X'8A' x'20'");
  spfservice("cmd","CHANGE ALL X'8B' x'20'");
  spfservice("cmd","CHANGE ALL X'8C' x'20'");
  spfservice("cmd","CHANGE ALL X'8D' x'20'");
  spfservice("cmd","CHANGE ALL X'8E' x'20'");
  spfservice("cmd","CHANGE ALL X'8F' x'20'");

  spfservice("cmd","CHANGE ALL X'90' x'20'");
  spfservice("cmd","CHANGE ALL X'91' x'20'");
  spfservice("cmd","CHANGE ALL X'92' x'20'");
  spfservice("cmd","CHANGE ALL X'93' x'20'");
  spfservice("cmd","CHANGE ALL X'94' x'20'");
  spfservice("cmd","CHANGE ALL X'95' x'20'");
  spfservice("cmd","CHANGE ALL X'96' x'20'");
  spfservice("cmd","CHANGE ALL X'97' x'20'");
  spfservice("cmd","CHANGE ALL X'98' x'20'");
  spfservice("cmd","CHANGE ALL X'99' x'20'");
  spfservice("cmd","CHANGE ALL X'9A' x'20'");
  spfservice("cmd","CHANGE ALL X'9B' x'20'");
  spfservice("cmd","CHANGE ALL X'9C' x'20'");
  spfservice("cmd","CHANGE ALL X'9D' x'20'");
  spfservice("cmd","CHANGE ALL X'9E' x'20'");
  spfservice("cmd","CHANGE ALL X'9F' x'20'");

  spfservice("cmd","CHANGE ALL X'A0' x'20'");
  spfservice("cmd","CHANGE ALL X'A1' x'20'");
  spfservice("cmd","CHANGE ALL X'A2' x'20'");
  spfservice("cmd","CHANGE ALL X'A3' x'20'");
  spfservice("cmd","CHANGE ALL X'A4' x'20'");
  spfservice("cmd","CHANGE ALL X'A5' x'20'");
  spfservice("cmd","CHANGE ALL X'A6' x'20'");
  spfservice("cmd","CHANGE ALL X'A7' x'20'");
  spfservice("cmd","CHANGE ALL X'A8' x'20'");
  spfservice("cmd","CHANGE ALL X'A9' x'20'");
  spfservice("cmd","CHANGE ALL X'AA' x'20'");
  spfservice("cmd","CHANGE ALL X'AB' x'20'");
  spfservice("cmd","CHANGE ALL X'AC' x'20'");
  spfservice("cmd","CHANGE ALL X'AD' x'20'");
  spfservice("cmd","CHANGE ALL X'AE' x'20'");
  spfservice("cmd","CHANGE ALL X'AF' x'20'");

  spfservice("cmd","CHANGE ALL X'B0' x'20'");
  spfservice("cmd","CHANGE ALL X'B1' x'20'");
  spfservice("cmd","CHANGE ALL X'B2' x'20'");
  spfservice("cmd","CHANGE ALL X'B3' x'20'");
  spfservice("cmd","CHANGE ALL X'B4' x'20'");
  spfservice("cmd","CHANGE ALL X'B5' x'20'");
  spfservice("cmd","CHANGE ALL X'B6' x'20'");
  spfservice("cmd","CHANGE ALL X'B7' x'20'");
  spfservice("cmd","CHANGE ALL X'B8' x'20'");
  spfservice("cmd","CHANGE ALL X'B9' x'20'");
  spfservice("cmd","CHANGE ALL X'BA' x'20'");
  spfservice("cmd","CHANGE ALL X'BB' x'20'");
  spfservice("cmd","CHANGE ALL X'BC' x'20'");
  spfservice("cmd","CHANGE ALL X'BD' x'20'");
  spfservice("cmd","CHANGE ALL X'BE' x'20'");
  spfservice("cmd","CHANGE ALL X'BF' x'20'");

  spfservice("cmd","CHANGE ALL X'C0' x'20'");
  spfservice("cmd","CHANGE ALL X'C1' x'20'");
  spfservice("cmd","CHANGE ALL X'C2' x'20'");
  spfservice("cmd","CHANGE ALL X'C3' x'20'");
  spfservice("cmd","CHANGE ALL X'C4' x'20'");
  spfservice("cmd","CHANGE ALL X'C5' x'20'");
  spfservice("cmd","CHANGE ALL X'C6' x'20'");
  spfservice("cmd","CHANGE ALL X'C7' x'20'");
  spfservice("cmd","CHANGE ALL X'C8' x'20'");
  spfservice("cmd","CHANGE ALL X'C9' x'20'");
  spfservice("cmd","CHANGE ALL X'CA' x'20'");
  spfservice("cmd","CHANGE ALL X'CB' x'20'");
  spfservice("cmd","CHANGE ALL X'CC' x'20'");
  spfservice("cmd","CHANGE ALL X'CD' x'20'");
  spfservice("cmd","CHANGE ALL X'CE' x'20'");
  spfservice("cmd","CHANGE ALL X'CF' x'20'");

  spfservice("cmd","CHANGE ALL X'D0' x'20'");
  spfservice("cmd","CHANGE ALL X'D1' x'20'");
  spfservice("cmd","CHANGE ALL X'D2' x'20'");
  spfservice("cmd","CHANGE ALL X'D3' x'20'");
  spfservice("cmd","CHANGE ALL X'D4' x'20'");
  spfservice("cmd","CHANGE ALL X'D5' x'20'");
  spfservice("cmd","CHANGE ALL X'D6' x'20'");
  spfservice("cmd","CHANGE ALL X'D7' x'20'");
  spfservice("cmd","CHANGE ALL X'D8' x'20'");
  spfservice("cmd","CHANGE ALL X'D9' x'20'");
  spfservice("cmd","CHANGE ALL X'DA' x'20'");
  spfservice("cmd","CHANGE ALL X'DB' x'20'");
  spfservice("cmd","CHANGE ALL X'DC' x'20'");
  spfservice("cmd","CHANGE ALL X'DD' x'20'");
  spfservice("cmd","CHANGE ALL X'DE' x'20'");
  spfservice("cmd","CHANGE ALL X'DF' x'20'");

  spfservice("cmd","CHANGE ALL X'E0' x'20'");
  spfservice("cmd","CHANGE ALL X'E1' x'20'");
  spfservice("cmd","CHANGE ALL X'E2' x'20'");
  spfservice("cmd","CHANGE ALL X'E3' x'20'");
  spfservice("cmd","CHANGE ALL X'E4' x'20'");
  spfservice("cmd","CHANGE ALL X'E5' x'20'");
  spfservice("cmd","CHANGE ALL X'E6' x'20'");
  spfservice("cmd","CHANGE ALL X'E7' x'20'");
  spfservice("cmd","CHANGE ALL X'E8' x'20'");
  spfservice("cmd","CHANGE ALL X'E9' x'20'");
  spfservice("cmd","CHANGE ALL X'EA' x'20'");
  spfservice("cmd","CHANGE ALL X'EB' x'20'");
  spfservice("cmd","CHANGE ALL X'EC' x'20'");
  spfservice("cmd","CHANGE ALL X'ED' x'20'");
  spfservice("cmd","CHANGE ALL X'EE' x'20'");
  spfservice("cmd","CHANGE ALL X'EF' x'20'");

  spfservice("cmd","CHANGE ALL X'F0' x'20'");
  spfservice("cmd","CHANGE ALL X'F1' x'20'");
  spfservice("cmd","CHANGE ALL X'F2' x'20'");
  spfservice("cmd","CHANGE ALL X'F3' x'20'");
  spfservice("cmd","CHANGE ALL X'F4' x'20'");
  spfservice("cmd","CHANGE ALL X'F5' x'20'");
  spfservice("cmd","CHANGE ALL X'F6' x'20'");
  spfservice("cmd","CHANGE ALL X'F7' x'20'");
  spfservice("cmd","CHANGE ALL X'F8' x'20'");
  spfservice("cmd","CHANGE ALL X'F9' x'20'");
  spfservice("cmd","CHANGE ALL X'FA' x'20'");
  spfservice("cmd","CHANGE ALL X'FB' x'20'");
  spfservice("cmd","CHANGE ALL X'FC' x'20'");
  spfservice("cmd","CHANGE ALL X'FD' x'20'");
  spfservice("cmd","CHANGE ALL X'FE' x'20'");
  spfservice("cmd","CHANGE ALL X'FF' x'20'");

  //------------------------------
  // change unary CRs/LFs to blank
  //------------------------------
  spfservice("cmd","CHANGE ALL X'0D0A' x'FFFF'"); // change valid CR+LF pairs to FFFF
  spfservice("cmd","CHANGE ALL X'0A' x'20'");     // change unary LFs to blank
  spfservice("cmd","CHANGE ALL X'0D' x'20'");     // change unary CRs to blank
  spfservice("cmd","CHANGE ALL X'FFFF' x'0D0A'"); // restore valid CR+LF pairs

} // FixBadChars
