//--------------------------------------------------------------------------
// How to Install
//
//   1) Rename macro source file to:  DBLCLICK.C
//
//   2) Put DBLCLICK.C in your COBOL source directory.
//
// After install, in Edit on a COBOL source file, double click on a copybook
// name and this macro will browse (or edit) that copybook in the current
// directory.
//
// Optional action (Edit or Brose) is set in var "action".
//
// Optional copybook path is set in var "path".
//
//--------------------------------------------------------------------------
void dblclick(void) {

  char *action = "BROWSE";  // default action is BROWSE
  //char *action = "EDIT";  // or set like this for EDIT

  char *path; // default copybook path is current directory (null)
  // char *path = "C:\\...copybook-path..."; // or provide explicit copybook path here

  char *pcmd;
  char *line_text;
  char *cur_word;
  int   cur_col;
  int   line_length;
  bool  any_error = FALSE;

  line_text = spfservice("query","line_data");
  line_length = strlen(line_text);
  cur_col  = spfservice("query","col_number");
  if (cur_col > 0 && cur_col <= line_length) {
    cur_word = strparseword(line_text,cur_col);
    if (strlen(cur_word) > 0) {
      pcmd = strcompose(action," ",path,cur_word,".COB");
      spfservice("cmd",pcmd);  // BROWSE (or EDIT) copybook in current directory
      }
    else {
      any_error = TRUE;
    }
    }
  else {
    any_error = TRUE;
  }
  if (any_error) {
    msg("DBLCLICK on copybook name to open copybook source file.");
  }

} // dblclick
