//------------------------------------------------------------------------------
// This macro LOCATEs to a specific byte within a file.
// To work correctly, a File Profile with RECFM=F when editing file in question.
// We recommend File Profile "F64".
// This macro takes one parameter:  P1 = byte-number  (base 10)
//------------------------------------------------------------------------------
void locbyte(int argc, char *argv[]) {

  char *pcmd;
  int   byte_pos;
  int   lrecl;
  int   target_linenum;
  int   cur_linenum;
  int   col;

  if (argc == 2) {
    byte_pos = argv[1]; // get P1
    if (byte_pos > 0) {
      SPFservice("cmd","LOCATE 1");              // locate first line
      lrecl = SPFservice("query","LINE_LENGTH"); // get LRECL
      target_linenum = byte_pos / lrecl; // number whole lines preceding target line
      col = byte_pos % lrecl; // number of bytes within line
      if (col == 0)
        col = lrecl; // target byte is last byte on line
      else
        ++target_linenum; // target line number
      pcmd = strcompose("LOCATE ",target_linenum);
      SPFservice("cmd",pcmd); // locate target line
      cur_linenum = SPFservice("query","LINE_NUMBER"); // get current line number
      if (cur_linenum == target_linenum) {
        SPFservice("set","CURSOR_ROW",1);   // put cursor on target line
        SPFservice("set","COL_NUMBER",col); // put cursor on target col
        }
      else {
        Msg("LOCBYTE:  target byte number is beyond end of file");
      }
      }
    else {
      Msg("LOCBYTE:  parameter 1, byte number, must be greater than 0");
    }
    }
  else {
    Msg("LOCBYTE:  requires one parameter:  P1 = byte-number");
  }

} // locbyte
