//--------------------------------------------------------------
// This macro demonstrates one way to implement a "word" parser.
// (Original macro concept by Rusty Stone, BMC Software)
//--------------------------------------------------------------
void parse(void) {
 
  char *line1 = "ABC   DEFG   HIJK=LMNO(PQR,ST) UVWXYZ";
  char *line2 = "  ABCDEFG  HIJK=LMNO(PQR,ST) UVWXYZ  ";
   
  ParseLine(line1);
  ParseLine(line2);
   
} // testmac
 
//----------
// ParseLine
//----------
void ParseLine(char *line) {
 
  char *word;
  int   linelen;
  int   i, j;
   
  Msg(StrCompose("Parsing: '",line,"'"); // show line being parsed
   
  //--------------------------
  // parse "line" into "words"
  //--------------------------
  linelen = strlen(line);
  i = 1;
  while (i <= linelen) {
    word = StrParseWord(line,i); // parse next word
    j = strlen(word);
    if (j > 0) {
      Msg(strcompose("Word parsed, col=",i,", '",word,"'");
      i += j; // resume parse at col after current word
      }
    else {
      ++i;    // no word found, resume parse at next col
    }
  } // while
   
} // ParseLine
