//-----------------------------------------------------------------------------
// This is a generic example of how you might read an external file and perform
// operations on the records within it. The OK clause of the "switch" is where
// the work would be done.
//-----------------------------------------------------------------------------
void ReadAFile(int argc, char *argv[]) {
 
  char *RC;
  char *record;
  int   fh;
  int   rec_count = 0;
  BOOL  eof = FALSE;
  BOOL  error = FALSE;

  if (argc == 2) {
    if (FileExist(argv[1])) {
      fh = FileOpen(argv[1],"r");
      if (fh == 0) {
        Msg(strcompose("Unable to open file '",argv[1],"' for READ.");
        }
      else {
        while (!error && !eof) {
          RC = FileRecRead(fh,record);
          switch(RC) {
           
            case "OK":
              //-----------------------------------
              // do record specific operations here
              //-----------------------------------
              ++rec_count;
              Msg(record);
              break;
               
            case "EOF":
              eof = TRUE;
              break;
               
            case "ERROR":
              error = TRUE;
              Msg(strcompose("Error reading file ",argv[1],", record number ",rec_count);
              break;
               
          } // switch
        }
        FileClose(fh);
      } // while
      }
    else {
      Msg(strcompose("File '",argv[1],"' does not exist.");
    }
    }
  else {
    Msg("This macro requires one parameter: P1 = filename");
  }
   
} // ReadAFile
