//--------------------------------------------------------------------------------
// Use this Edit macro to align text lines flush right to a specific column width.
//
// All text lines must be equal or less than column width.
//
// Requires one parameter:  column-width
//
// Example:  RIGHTALIGN 10
//
//--------------------------------------------------------------------------------
void RightAlign(int argc, char *argv[]) {

  char *context;
  char *line_data;
  char *pcmd;
  char *buf;
  int   col_width;
  int   line_count;
  int   line_length;
  int   line_number;

  context = spfservice("query","context");
  if (context == "EDIT") {
    if (argc == 2) {
      col_width = argv[1]; // get P1
      if (col_width > 1 && col_width < 100) {
        line_count = spfservice("query","line_count");
        if (line_count > 0) {
          line_number = 1;
          while (line_number <= line_count) {
            pcmd = strcompose("locate ",line_number);
            spfservice("cmd",pcmd);
            // at this point you are LOCATED to current line
            line_data = spfservice("query","line_data");
            line_length = strlen(line_data);
            if (line_length < col_width) {
              buf = ""; // reset
              while (line_length < col_width) {
                strcat(buf," ");
                ++line_length;
              } // while
              strcat(buf,line_data);
              spfservice("set","line_data",buf);
            }
            if (line_length > col_width)
              msg(strcompose("RIGHTALIGN line ",line_number," longer than col width, ignored"));
            ++line_number;
          } // while
          spfservice("cmd","top");
          }
        else {
          msg("RIGHTALIGN no lines, nothing to do.");
        }
        }
      else {
        msg("RIGHTALIGN column width must be greater than 1 and less than 100");
      }
      }
    else {
      msg("RIGHTALIGN requires one parameter:  p1 = column-width");
    }
    }
  else {
    msg("RIGHTALIGN you must be in Edit to use this macro.");
  }

} // RightAlign
