//------------------------------------------------------------------
// Macro:     SEQNUM
// Function:  Put a sequence number in the current line
//------------------------------------------------------------------
// Assign this macro to a PF (or CTRL) key.
//
// Type the desired sequence number in the primary command field.
//
// Press the PF (or CTRL) key to get current line sequence numbered.
//------------------------------------------------------------------
void seqnum(int argc, char *argv[]) {

  //-------------------------------------------------------------------------------------
  // Set sequence number "start_col" and sequence number field "width" to suit your needs
  //-------------------------------------------------------------------------------------
  int   start_col = 73; // sequence number start column
  int   width = 8;      // sequence number field width

  char *line_str;
  char *context;
  char *final_num;
  char *seqnum_str;
  int   seqnum_len;
  int   last_line_col;
  int   i;

  if (argc == 2) {
    context = spfservice("query","context");
    if (context == "EDIT") {
      line_str = spfservice("query","line_data");
      final_num = ""; // reset
      i = width;
      while (i) {
        strcat(final_num,"0");
        --i;
      } // while
      seqnum_str = argv[1];                   // Parm 1, seq number, to local string
      seqnum_len = strlen(seqnum_str);        // get length of sequence number
      if (seqnum_len <= width) {              // seq num fit in seq num field?
        i = width - seqnum_len;               // get difference in length
        i += 1;                               // start col for final number overlay
        strovlsubstr(final_num,seqnum_str,i); // "final_num" now "width" wide, left padded with 0s
        last_line_col = strlen(line_str);     // last col of line
        i = start_col + width - 1;            // last col of sequence number
        while(last_line_col < i) {            // sequence number overflow line?
          strcat(line_str," ");               // append blank to line
          ++last_line_col;                    // adjust last col number
        } // while
        strovlsubstr(line_str,final_num,start_col); // overlay line data with final sequence number
        }
      else {
        msg("SEQNUM parameter 1, sequence number, wider than sequence number field");
      }
      spfservice("set","line_data",line_str);
      }
    else {
      msg("SEQNUM macro only allowed in Edit.");
    }
    }
  else {
    msg("SEQNUM macro requires 1 parameter:  P1 = sequence-number");
  }

} // seqnum
