//-------------------------------------------------------------
// This macro demonstrates the standard method of declaring and
// accessing parameters in the "main" function of a macro.
//
// Parm 1, ARGC, the count of parameters passed.
//
// Parm 2, ARGV, an array of character strings
//               argv[0] = macro`s fully qualified path name
//               argv[1] = parameter 1
//               argv[2] = parameter 2
//               ...
//               argv[argc-1] = last parameter
//
//-------------------------------------------------------------
void ShowParms(int argc, char *argv[]) {

  char *msg_buf;
  char *p_buf;
  int   i;

  i = 0;
  while (i < argc) {
    p_buf = strcompose("P",i," = ",argv[i]);
    strcat(msg_buf,p_buf);
    strcat(msg_buf,"\n");
    ++i;
  } // while
  msg(msg_buf);

} // ShowParms
