//----------------------------------------------------------------------------
// Use this macro to move the text at the current cursor position to the right
// to a new column position.
//
// The cursor must be on a data column.
//
// This macro requires on parameter:  to-column
//
// The "to column" must be to the right of the cursor column.
//
//----------------------------------------------------------------------------
void tocol(int argc, char *argv[]) {

  char *cur_line_data;
  char *new_line_data;
  char *line_seg1;
  char *line_seg2 = "";
  char *line_seg3;
  int   cur_col, to_col;
  int   line_len, seg1_len, seg2_len, seg3_len;
  int   i;

  if (argc == 2) {
    cur_line_data = spfservice("query","line_data");
    cur_col = spfservice("query","col_number");
    if (cur_col > 0) {
      line_len = strlen(cur_line_data);
      if (line_len > cur_col) {
        to_col = argv[1];
        if (to_col > cur_col) {
          seg1_len = cur_col - 1;
          seg2_len = to_col - cur_col;
          seg3_len = line_len - seg1_len;
          line_seg1 = strgetsubstr(cur_line_data,1,seg1_len);
          line_seg3 = strgetsubstr(cur_line_data,cur_col,seg3_len);
          i = seg2_len;
          while (i > 0) {
            strcat(line_seg2," ");
            --i;
          } // while
          new_line_data = strcompose(line_seg1,line_seg2,line_seg3);
          spfservice("set","line_data",new_line_data);
          //spfservice("set","col_number",to_col);
          }
        else {
          msg("TOCOL:  TO col must be to right of cursor col");
        }
        }
      else {
        msg("TOCOL:  cursor must be within line data");
      }
      }
    else {
      msg("TOCOL:  cursor col must be greater than 0");
    }
    }
  else {
    msg("TOCOL:  requires one parameter:  column-number");
  }

} // tocol
