//------------------------------------------------------------------------------
// This is an example macro which shows how "commit" of a macro launched dialog
// would be handled. The dialog "user1" was launched by macro "user1.c". When
// 3270ENTER key is pressed (or OK button clicked), this macro receives control.
// If the dialog is cancelled via F3(END), normal SPF/SE processing resumes.
//------------------------------------------------------------------------------
void User1Commit(void) {

  char *text;
  char *choice;
  char *cur_item;
  char *lcmd;
  char *lcmd_varname;
  char *item_varname;
  int   cur_item_number;
  int   item_count;
  int   number;
  BOOL  boolval;
  BOOL  any_error = FALSE;

  text    = spfservice("vget","User1.TextIn");      // retrieve dialog variable
  choice  = spfservice("vget","User1.ChoiceIn");    // retrieve dialog variable
  number  = spfservice("vget","User1.NumIn");       // retrieve dialog variable
  boolval = spfservice("vget","User1.BoolIn");      // retrieve dialog variable
  item_count = spfservice("vget","User1.List.0");   // retrieve number of items in list
  msg(strcompose("Current field values:\n\nText=",text,"\nNumber=",number,"\nChoice=",choice,"\nBool=",boolval));
  if (item_count > 0) {
    cur_item_number = 1;
    //trace("on");
    while (!any_error && cur_item_number <= item_count) {
      strcpy(lcmd_varname,"ZLISTLCMD.");
      strcat(lcmd_varname,cur_item_number);         // synthesize varname to retrieve line command
      lcmd = spfservice("vget",lcmd_varname);       // get line command
      if (strlen(lcmd) > 0) {                       // line command present?
        strupr(lcmd);                               // make line command upcase
        spfservice("vput",lcmd_varname,"");         // reset line command var
        strcpy(item_varname,"User1.List.");
        strcat(item_varname,cur_item_number);       // synthesize varname to retrieve item
        cur_item = spfservice("vget",item_varname); // retrieve list item
        switch (lcmd) {

          case "S":
            //--------------------
            // SELECT line command
            //--------------------
            Msg(strcompose("Apply SELECT to:  ",cur_item));
            // ... this is where you put your action code ...
            break;

          case "R":
            //--------------------
            // RENAME line command
            //--------------------
            Msg(strcompose("Apply RENAME to:  ",cur_item));
            // ... this is where you put your action code ...
            break;

          case "D":
            //--------------------
            // DELETE line command
            //--------------------
            Msg(strcompose("Apply DELETE to:  ",cur_item));
            // ... this is where you put your action code ...
            break;

          case "M":
            //-----------------------
            // MOVETOTOP line command
            //-----------------------
            Msg(strcompose("Apply MOVETOTOP to:  ",cur_item));
            // ... this is where you put your action code ...
            break;

          default:
            any_error = TRUE;
            Msg(strcompose("List item  ",cur_item_number,"  has unknown line command:  ",lcmd));
            break;

        } // switch
      }
      ++cur_item_number;
    } // while
  }

  //-------------------------------------------------------------------------
  // The following optional call causes the parent macro to be executed again
  // producing the effect of "loop until cancel". If you do not have a need
  // for this, delete following statement.
  //
  // NOTE: If used, this must be the last statement in your macro.
  //-------------------------------------------------------------------------
  spfservice("queuemacro","user1"); // queue macro for re-execution

} // User1Commit
